#include <math.h>
#include <stdio.h>
#include "libppm.h"

/* r g
   g b -- unlike the QC, both greens are really greens */

int s(int g, int fac) {
  return ((int)pow(g, 1+(fac/8.0)))>>fac;
}

int main(int argc, char **argv) {
  int i, j;
  struct ppm_image in, out;
  unsigned char *t;
  FILE *fin = (argc >= 2) ? fopen(argv[1], "r") : stdin;
  FILE *fout = (argc >= 3) ? fopen(argv[2], "w") : stdout;
  int stretch = (argc >= 4) ? (!strcmp(argv[3], "-s")) : 0;
  ppminit(&in);  ppminit(&out);
  ppmread(fin, &in);
  if (!stretch) {
    ppmalloc(&out, in.width/2, in.height/2);
    for (j=0; j<out.height; j++)
      for (i=0; i<out.width; i++) {
        out.data[(i+j*out.width)*3]   = in.data[(i*2 + (j*2)*in.width)*3];
        out.data[(i+j*out.width)*3+1] = s((in.data[(i*2+1 + (j*2)*in.width)*3] +
                                   in.data[(i*2 + (j*2+1)*in.width)*3])/2, 7);
        out.data[(i+j*out.width)*3+2] = s(in.data[(i*2+1 + (j*2+1)*in.width)*3], 3);
      }
  }
  else {
    ppmalloc(&out, in.width, in.height);
    for (i=0; i<out.width; i++)
      for (j=0; j<out.height; j++) {
        t = &in.data[(i+j*in.width)*3];
        switch ((i%2) + (j%2)*2) {
          case 0:  /* red */
            out.data[(i+j*out.width)*3] = *t;
            out.data[(i+j*out.width)*3+1] = s((*(t+3) + *(t+3*in.width) +
                                             *(t-3) + *(t-3*in.width))/4, 7);
            out.data[(i+j*out.width)*3+2] = s((*(t-(3+3*in.width)) +
                                             *(t+(3+3*in.width)))/2, 3);
            break;
          case 1:  /* green1 */
            out.data[(i+j*out.width)*3] = (*(t+3) + *(t-3))/2;
            out.data[(i+j*out.width)*3+1] = s(*t, 7);
            out.data[(i+j*out.width)*3+2] = s((*(t+3*in.width) +
                                             *(t-3*in.width))/2, 3);
            break;
          case 2:  /* green2 */
            out.data[(i+j*out.width)*3] = (*(t+3*in.width) +
                                           *(t-3*in.width))/2;
            out.data[(i+j*out.width)*3+1] = s(*t, 7);
            out.data[(i+j*out.width)*3+2] = s((*(t+3) + *(t-3))/2, 3);
            break;
          case 3:  /* blue */
            out.data[(i+j*out.width)*3] = (*(t-(3+3*in.width)) +
                                           *(t+(3+3*in.width)))/2;
            out.data[(i+j*out.width)*3+1] = s((*(t+3) + *(t+3*in.width) +
                                             *(t-3) + *(t-3*in.width))/4, 7);
            out.data[(i+j*out.width)*3+2] = s(*t, 3);
            break;
        }
      }
  }
  ppmwrite(fout, &out);
  ppmdestroy(&in);
  ppmdestroy(&out);
  return 0;
}
